// MiniPro GUI: Einfaches grafisches Bediener Interface für den TL866
// MiniPro Programmer unter Linux
//
// generated by Fast Light User Interface Designer (fluid) version 1.0303

#include "minipro_gui.h"
#include <FL/Fl_File_Chooser.H>
#include <Fl/Fl_Multiline_Output.H>
#include <iostream>

Fl_Multiline_Output *output;

int execCmd(char *cmd)
{
	FILE *f;
	int r;
	char st1[10];
	
	output->value("");		// Multiline_Output: Inhalt löschen
	output->insert(cmd);	// Befehlszeile & Leerzeile anzeigen
	output->insert("\n");
	strcat(cmd," 2>&1");	// stderr auf stdout umleiten
	f=popen(cmd,"r");		// externes Programm starten 
	while(!feof(f)){
	  r=fread(st1,1,1,f);	// Ausgabe mitlesen
	  // ??? Zeichen Filterung ???
	  output->insert(st1,1);
	  Fl::flush();			// Anzeige aktualisieren
	}
	return pclose(f);
}

void Btn_File_CB(Fl_Widget*,void*) {
  char* file;

  file = fl_file_chooser("Select: Code/Data File (*.bin), Fuse File (*.conf)", "*.{bin,conf}", 0);
  flashfile->value(file);
}

void Btn_Exec_CB(Fl_Widget*,void*) {
  char cmd [200];

  switch (sel_mode->value()) {
	  case 0: // Read All Funktion
		sprintf(cmd, "minipro -p %s -r flash.bin", device_type->text(device_type->value()));
		break;
	  case 1: // Write Code Funktion
		sprintf(cmd, "minipro -p %s -c code -e -w %s", device_type->text(device_type->value()), flashfile->value());
		break;
	  case 2: // Write Data Funktion
		sprintf(cmd, "minipro -p %s -c data -e -w %s", device_type->text(device_type->value()), flashfile->value());
		break;
	  case 3: // Write Fuses Funktion
		sprintf(cmd, "minipro -p %s -c config -e -w %s", device_type->text(device_type->value()), flashfile->value());
		break;
  }
  if (execCmd(cmd)) fl_alert("Operation Failure!");
}

Fl_Choice *device_type=(Fl_Choice *)0;
Fl_Input *flashfile=(Fl_Input *)0;
Fl_Button *Btn_File=(Fl_Button *)0;
Fl_Choice *sel_mode=(Fl_Choice *)0;
Fl_Button *Btn_Exec=(Fl_Button *)0;

int main(int argc, char **argv) {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = new Fl_Double_Window(565, 500, "MiniPro Programmer GUI");
    w = o;
    { device_type = new Fl_Choice(5, 11, 215, 24, "Device");
      device_type->down_box(FL_BORDER_BOX);
      device_type->align(Fl_Align(FL_ALIGN_RIGHT));
      // eigene Ergänzungen (noch unvollständig)
      device_type->add("ATMEGA8");
      device_type->add("ATMEGA16");
      device_type->add("ATMEGA32");
      device_type->add("ATMEGA48");
      device_type->add("ATMEGA88");
      device_type->add("ATMEGA168");
      device_type->add("ATMEGA324");
      device_type->add("ATMEGA328");
      device_type->add("ATMEGA644A");
      device_type->add("ATMEGA1284");
      device_type->add("ATMEGA8515");
      device_type->add("ATMEGA8535");
      device_type->add("ATTINY13");
      device_type->add("ATTINY24");
      device_type->add("ATTINY26");
      device_type->add("ATTINY44");
      device_type->add("ATTINY45");
      device_type->add("ATTINY84");
      device_type->add("ATTINY85");
      device_type->add("ATTINY2313");
      device_type->add("ATTINY4313");
      device_type->value(0);			// 1. Eintrag
    } // Fl_Choice* device_type
    
    { flashfile = new Fl_Input(5, 51, 490, 24);
    } // Fl_Input* flashfile
    
    { Btn_File = new Fl_Button(500, 45, 60, 30, "File");
      Btn_File->callback((Fl_Callback*)Btn_File_CB);
    } // Fl_Button* Btn_File
    
    { sel_mode = new Fl_Choice(280, 10, 215, 25, "Function");
      sel_mode->down_box(FL_BORDER_BOX);
      sel_mode->align(Fl_Align(FL_ALIGN_RIGHT));
	  // eigene Ergänzungen
      sel_mode->add("Read All");
      sel_mode->add("Write Code");
      sel_mode->add("Write Data");
      sel_mode->add("Write Fuses");
      sel_mode->value(0);				// 1. Eintrag
    } // Fl_Choice* sel_mode
    
    { Btn_Exec = new Fl_Button(195, 90, 110, 45, "Start");
      Btn_Exec->labelsize(24);
      Btn_Exec->labelcolor((Fl_Color)4);
      Btn_Exec->callback((Fl_Callback*)Btn_Exec_CB);
    } // Fl_Button* Btn_Exec
    
      output=new Fl_Multiline_Output(5,150,550,345);
      output->tooltip("minipro messages");
      
    o->end();
  } // Fl_Double_Window* o
  w->show(argc, argv);
  return Fl::run();
}
